diff --git a/src/backend/postmaster/postmaster.c b/src/backend/postmaster/postmaster.c
index ba9528d5dfa..3be146abac2 100644
--- a/src/backend/postmaster/postmaster.c
+++ b/src/backend/postmaster/postmaster.c
@@ -110,9 +110,11 @@
 #include "replication/slotsync.h"
 #include "replication/walsender.h"
 #include "storage/aio_subsys.h"
+#include "storage/bufmgr.h"
 #include "storage/fd.h"
 #include "storage/io_worker.h"
 #include "storage/ipc.h"
+#include "storage/pg_shmem.h"
 #include "storage/pmsignal.h"
 #include "storage/proc.h"
 #include "tcop/backend_startup.h"
@@ -125,7 +127,6 @@
 
 #ifdef EXEC_BACKEND
 #include "common/file_utils.h"
-#include "storage/pg_shmem.h"
 #endif
 
 
@@ -959,6 +960,11 @@ PostmasterMain(int argc, char *argv[])
 	 */
 	InitializeFastPathLocks();
 
+	/*
+	 * Calculate MaxNBuffers for buffer pool resizing.
+	 */
+	InitializeMaxNBuffers();
+
 	/*
 	 * Give preloaded libraries a chance to request additional shared memory.
 	 */
@@ -1698,9 +1704,6 @@ ServerLoop(void)
 			if (pending_pm_pmsignal)
 				process_pm_pmsignal();
 
-			if (pending_pm_shmem_resize)
-				process_pm_shmem_resize();
-
 			if (events[i].events & WL_SOCKET_ACCEPT)
 			{
 				ClientSocket s;
@@ -2046,15 +2049,34 @@ process_pm_reload_request(void)
 	}
 }
 
+/*
+ * Handle requests from the coordinator to resize shared memory maps so that the
+ * new backends can inherit those.
+ */
 static void
 process_pm_shmem_resize(void)
 {
+	elog(LOG, "postmaster received PMSIGNAL_SHMEM_RESIZE, coordinating memory remapping");
+	
 	/*
-	 * Failure to resize is considered to be fatal and will not be
-	 * retried, which means we can disable pending flag right here.
+	 * Perform the memory remapping in postmaster process. This should never fail
+	 * since the address map is always reserved. If it fails the address maps in
+	 * the backends will becomes inconsistent which is a fundamental assumption
+	 * in PostgreSQL architecture. Hence PANIC.
 	 */
-	pending_pm_shmem_resize = false;
-	CoordinateShmemResize();
+	if (!AnonymousShmemResize())
+		elog(PANIC, "postmaster failed to resize anonymous shared memory");
+	else
+	{
+		int targetNBuffers = pg_atomic_read_u32(&ShmemCtrl->targetNBuffers);
+		elog(LOG, "postmaster successfully completed shared memory remapping");
+
+		BufferManagerShmemValidate(targetNBuffers);
+		elog(LOG, "postmaster successfully validated buffer manager shared memory");
+		ShmemCtrl->pmwork_done = true;
+		ConditionVariableBroadcast(&ShmemCtrl->pm_cv);
+		NBuffers = targetNBuffers;
+	}
 }
 
 /*
@@ -3878,7 +3900,7 @@ process_pm_pmsignal(void)
 	}
 
 	if (CheckPostmasterSignal(PMSIGNAL_SHMEM_RESIZE))
-		AnonymousShmemResize();
+		process_pm_shmem_resize();
 
 	/*
 	 * Try to advance postmaster's state machine, if a child requests it.
diff --git a/src/backend/storage/buffer/buf_init.c b/src/backend/storage/buffer/buf_init.c
index be64fa5a136..80a168ec2ce 100644
--- a/src/backend/storage/buffer/buf_init.c
+++ b/src/backend/storage/buffer/buf_init.c
@@ -19,6 +19,7 @@
 #include "storage/pg_shmem.h"
 #include "storage/bufmgr.h"
 #include "storage/pg_shmem.h"
+#include "utils/guc.h"
 
 BufferDescPadded *BufferDescriptors;
 char	   *BufferBlocks;
@@ -63,47 +64,39 @@ CkptSortItem *CkptBufferIds;
 /*
  * Initialize shared buffer pool
  *
- * This is called once during shared-memory initialization (either in the
- * postmaster, or in a standalone backend) or during shared-memory resize. Size
- * of data structures initialized here depends on NBuffers, and to be able to
- * change NBuffers without a restart we store each structure into a separate
- * shared memory segment, which could be resized on demand.
- *
- * FirstBufferToInit tells where to start initializing buffers. For
- * initialization it always will be zero, but when resizing shared-memory it
- * indicates the number of already initialized buffers.
- *
+ * This is called once during shared-memory initialization.
+ * TODO: Restore this function to it's initial form. This function should see no
+ * change in buffer resize patches, except may be use of NBuffersPending.
+ * 
  * No locks are taking in this function, it is the caller responsibility to
  * make sure only one backend can work with new buffers.
  */
 void
-BufferManagerShmemInit(int FirstBufferToInit)
+BufferManagerShmemInit(void)
 {
 	bool		foundBufs,
 				foundDescs,
 				foundIOCV,
 				foundBufCkpt;
 	int			i;
-	elog(DEBUG1, "BufferManagerShmemInit from %d to %d",
-				 FirstBufferToInit, NBuffers);
 
 	/* Align descriptors to a cacheline boundary. */
 	BufferDescriptors = (BufferDescPadded *)
 		ShmemInitStructInSegment("Buffer Descriptors",
-						NBuffers * sizeof(BufferDescPadded),
+						NBuffersPending * sizeof(BufferDescPadded),
 						&foundDescs, BUFFER_DESCRIPTORS_SHMEM_SEGMENT);
 
 	/* Align buffer pool on IO page size boundary. */
 	BufferBlocks = (char *)
 		TYPEALIGN(PG_IO_ALIGN_SIZE,
 				  ShmemInitStructInSegment("Buffer Blocks",
-								  NBuffers * (Size) BLCKSZ + PG_IO_ALIGN_SIZE,
+								  NBuffersPending * (Size) BLCKSZ + PG_IO_ALIGN_SIZE,
 								  &foundBufs, BUFFERS_SHMEM_SEGMENT));
 
 	/* Align condition variables to cacheline boundary. */
 	BufferIOCVArray = (ConditionVariableMinimallyPadded *)
 		ShmemInitStructInSegment("Buffer IO Condition Variables",
-						NBuffers * sizeof(ConditionVariableMinimallyPadded),
+						NBuffersPending * sizeof(ConditionVariableMinimallyPadded),
 						&foundIOCV, BUFFER_IOCV_SHMEM_SEGMENT);
 
 	/*
@@ -115,7 +108,7 @@ BufferManagerShmemInit(int FirstBufferToInit)
 	 */
 	CkptBufferIds = (CkptSortItem *)
 		ShmemInitStructInSegment("Checkpoint BufferIds",
-						NBuffers * sizeof(CkptSortItem), &foundBufCkpt,
+						NBuffersPending * sizeof(CkptSortItem), &foundBufCkpt,
 						CHECKPOINT_BUFFERS_SHMEM_SEGMENT);
 
 	if (foundDescs || foundBufs || foundIOCV || foundBufCkpt)
@@ -124,15 +117,14 @@ BufferManagerShmemInit(int FirstBufferToInit)
 		Assert(foundDescs && foundBufs && foundIOCV && foundBufCkpt);
 		/*
 		 * note: this path is only taken in EXEC_BACKEND case when initializing
-		 * shared memory, or in all cases when resizing shared memory.
+		 * shared memory.
 		 */
 	}
 
-#ifndef EXEC_BACKEND
 	/*
 	 * Initialize all the buffer headers.
 	 */
-	for (i = FirstBufferToInit; i < NBuffers; i++)
+	for (i = 0; i < NBuffersPending; i++)
 	{
 		BufferDesc *buf = GetBufferDescriptor(i);
 
@@ -150,21 +142,18 @@ BufferManagerShmemInit(int FirstBufferToInit)
 
 		ConditionVariableInit(BufferDescriptorGetIOCV(buf));
 	}
-#endif
 
 	/*
-	 * Init other shared buffer-management stuff from scratch configuring buffer
-	 * pool the first time. If we are just resizing buffer pool adjust only the
-	 * required structures.
+	 * Init other shared buffer-management stuff.
 	 */
-	if (FirstBufferToInit == 0)
-		StrategyInitialize(!foundDescs);
-	else
-		StrategyReInitialize(FirstBufferToInit);
+	StrategyInitialize(!foundDescs);
 
 	/* Initialize per-backend file flush context */
 	WritebackContextInit(&BackendWritebackContext,
 						 &backend_flush_after);
+	
+	/* Declare the size of current buffer pool. */
+	NBuffers = NBuffersPending;
 }
 
 /*
@@ -175,30 +164,61 @@ BufferManagerShmemInit(int FirstBufferToInit)
  * shared memory segment. The main segment must not allocate anything
  * related to buffers, every other segment will receive part of the
  * data.
+ * 
+ * If set_reserved is true, also sets the shmem_reserved field for each
+ * segment based on MaxNBuffers. This should be true during server startup
+ * but false during buffer pool resizing.
  */
 Size
-BufferManagerShmemSize(void)
+BufferManagerShmemSize(bool set_reserved)
 {
 	size_t size;
 
 	/* size of buffer descriptors, plus alignment padding */
-	size = add_size(0, mul_size(NBuffers, sizeof(BufferDescPadded)));
+	size = add_size(0, mul_size(NBuffersPending, sizeof(BufferDescPadded)));
 	size = add_size(size, PG_CACHE_LINE_SIZE);
 	Mappings[BUFFER_DESCRIPTORS_SHMEM_SEGMENT].shmem_req_size = size;
+	if (set_reserved)
+	{
+		/* reserved size based on MaxNBuffers */
+		size = add_size(0, mul_size(MaxNBuffers, sizeof(BufferDescPadded)));
+		size = add_size(size, PG_CACHE_LINE_SIZE);
+		Mappings[BUFFER_DESCRIPTORS_SHMEM_SEGMENT].shmem_reserved = size;
+	}
 
 	/* size of data pages, plus alignment padding */
 	size = add_size(0, PG_IO_ALIGN_SIZE);
-	size = add_size(size, mul_size(NBuffers, BLCKSZ));
+	size = add_size(size, mul_size(NBuffersPending, BLCKSZ));
 	Mappings[BUFFERS_SHMEM_SEGMENT].shmem_req_size = size;
+	if (set_reserved)
+	{
+		/* reserved size based on MaxNBuffers */
+		size = add_size(0, PG_IO_ALIGN_SIZE);
+		size = add_size(size, mul_size(MaxNBuffers, BLCKSZ));
+		Mappings[BUFFERS_SHMEM_SEGMENT].shmem_reserved = size;
+	}
 
 	/* size of I/O condition variables, plus alignment padding */
-	size = add_size(0, mul_size(NBuffers,
+	size = add_size(0, mul_size(NBuffersPending,
 								   sizeof(ConditionVariableMinimallyPadded)));
 	size = add_size(size, PG_CACHE_LINE_SIZE);
 	Mappings[BUFFER_IOCV_SHMEM_SEGMENT].shmem_req_size = size;
+	if (set_reserved)
+	{
+		/* reserved size based on MaxNBuffers */
+		size = add_size(0, mul_size(MaxNBuffers,
+									   sizeof(ConditionVariableMinimallyPadded)));
+		size = add_size(size, PG_CACHE_LINE_SIZE);
+		Mappings[BUFFER_IOCV_SHMEM_SEGMENT].shmem_reserved = size;
+	}
 
 	/* size of checkpoint sort array in bufmgr.c */
-	Mappings[CHECKPOINT_BUFFERS_SHMEM_SEGMENT].shmem_req_size = mul_size(NBuffers, sizeof(CkptSortItem));
+	Mappings[CHECKPOINT_BUFFERS_SHMEM_SEGMENT].shmem_req_size = mul_size(NBuffersPending, sizeof(CkptSortItem));
+	if (set_reserved)
+	{
+		/* reserved size based on MaxNBuffers */
+		Mappings[CHECKPOINT_BUFFERS_SHMEM_SEGMENT].shmem_reserved = mul_size(MaxNBuffers, sizeof(CkptSortItem));
+	}
 
 	/* Allocations in the main memory segment, at the end. */
 
@@ -207,3 +227,181 @@ BufferManagerShmemSize(void)
 
 	return size;
 }
+
+/*
+ * Reinitialize shared buffer manager structures when resizing the buffer pool.
+ *
+ * This function is called in the backend which coordinates buffer resizing
+ * operation.
+ *
+ * TODO: Avoid code duplication with BufferManagerShmemInit() and also assess
+ * which functionality in the latter is required in this function.
+ */
+void
+BufferManagerShmemResize(int currentNBuffers, int targetNBuffers)
+{
+	bool found;
+	int			i;
+	void *tmpPtr;
+
+	tmpPtr = (BufferDescPadded *)
+		ShmemUpdateStructInSegment("Buffer Descriptors",
+						targetNBuffers * sizeof(BufferDescPadded),
+						&found, BUFFER_DESCRIPTORS_SHMEM_SEGMENT);
+	if (BufferDescriptors != tmpPtr || !found)
+		elog(FATAL, "resizing buffer descriptors failed: expected pointer %p, got %p, found=%d",
+			 BufferDescriptors, tmpPtr, found);
+
+	tmpPtr = (ConditionVariableMinimallyPadded *)
+		ShmemUpdateStructInSegment("Buffer IO Condition Variables",
+						targetNBuffers * sizeof(ConditionVariableMinimallyPadded),
+						&found, BUFFER_IOCV_SHMEM_SEGMENT);
+	if (BufferIOCVArray != tmpPtr || !found)
+		elog(FATAL, "resizing buffer IO condition variables failed: expected pointer %p, got %p, found=%d",
+			 BufferIOCVArray, tmpPtr, found);
+
+	tmpPtr = (CkptSortItem *)
+		ShmemUpdateStructInSegment("Checkpoint BufferIds",
+						targetNBuffers * sizeof(CkptSortItem), &found,
+						CHECKPOINT_BUFFERS_SHMEM_SEGMENT);
+	if (CkptBufferIds != tmpPtr || !found)
+		elog(FATAL, "resizing checkpoint buffer IDs failed: expected pointer %p, got %p, found=%d",
+			 CkptBufferIds, tmpPtr, found);
+
+	tmpPtr = (char *)
+		TYPEALIGN(PG_IO_ALIGN_SIZE,
+				  ShmemUpdateStructInSegment("Buffer Blocks",
+								  targetNBuffers * (Size) BLCKSZ + PG_IO_ALIGN_SIZE,
+								  &found, BUFFERS_SHMEM_SEGMENT));
+	if (BufferBlocks != tmpPtr || !found)
+		elog(FATAL, "resizing buffer blocks failed: expected pointer %p, got %p, found=%d",
+			 BufferBlocks, tmpPtr, found);
+
+	/*
+	 * Initialize the headers for new buffers. If we are shrinking the
+	 * buffers, currentNBuffers >= targetNBuffers, thus this loop doesn't execute.
+	 */
+	for (i = currentNBuffers; i < targetNBuffers; i++)
+	{
+		BufferDesc *buf = GetBufferDescriptor(i);
+
+		ClearBufferTag(&buf->tag);
+
+		pg_atomic_init_u32(&buf->state, 0);
+		buf->wait_backend_pgprocno = INVALID_PROC_NUMBER;
+
+		buf->buf_id = i;
+
+		LWLockInitialize(BufferDescriptorGetContentLock(buf),
+						 LWTRANCHE_BUFFER_CONTENT);
+
+		ConditionVariableInit(BufferDescriptorGetIOCV(buf));
+	}
+
+	StrategyReset(targetNBuffers);
+}
+
+/*
+ * BufferManagerShmemValidate
+ *		Validate that buffer manager shared memory structures have correct
+ *		pointers and sizes after a resize operation.
+ *
+ * This function is called by backends during ProcessBarrierShmemResizeStruct
+ * to ensure their view of the buffer structures is consistent after memory
+ * remapping.
+ */
+void
+BufferManagerShmemValidate(int targetNBuffers)
+{
+	bool found;
+	void *tmpPtr;
+
+	/* Validate Buffer Descriptors */
+	tmpPtr = (BufferDescPadded *)
+		ShmemInitStructInSegment("Buffer Descriptors",
+						targetNBuffers * sizeof(BufferDescPadded),
+						&found, BUFFER_DESCRIPTORS_SHMEM_SEGMENT);
+	if (!found || BufferDescriptors != tmpPtr)
+		elog(FATAL, "validating buffer descriptors failed: expected pointer %p, got %p, found=%d",
+			 BufferDescriptors, tmpPtr, found);
+
+	/* Validate Buffer IO Condition Variables */
+	tmpPtr = (ConditionVariableMinimallyPadded *)
+		ShmemInitStructInSegment("Buffer IO Condition Variables",
+						targetNBuffers * sizeof(ConditionVariableMinimallyPadded),
+						&found, BUFFER_IOCV_SHMEM_SEGMENT);
+	if (!found || BufferIOCVArray != tmpPtr)
+		elog(FATAL, "validating buffer IO condition variables failed: expected pointer %p, got %p, found=%d",
+			 BufferIOCVArray, tmpPtr, found);
+
+	/* Validate Checkpoint BufferIds */
+	tmpPtr = (CkptSortItem *)
+		ShmemInitStructInSegment("Checkpoint BufferIds",
+						targetNBuffers * sizeof(CkptSortItem), &found,
+						CHECKPOINT_BUFFERS_SHMEM_SEGMENT);
+	if (!found || CkptBufferIds != tmpPtr)
+		elog(FATAL, "validating checkpoint buffer IDs failed: expected pointer %p, got %p, found=%d",
+			 CkptBufferIds, tmpPtr, found);
+
+	/* Validate Buffer Blocks */
+	tmpPtr = (char *)
+		TYPEALIGN(PG_IO_ALIGN_SIZE,
+				  ShmemInitStructInSegment("Buffer Blocks",
+								  targetNBuffers * (Size) BLCKSZ + PG_IO_ALIGN_SIZE,
+								  &found, BUFFERS_SHMEM_SEGMENT));
+	if (!found || BufferBlocks != tmpPtr)
+		elog(FATAL, "validating buffer blocks failed: expected pointer %p, got %p, found=%d",
+			 BufferBlocks, tmpPtr, found);
+}
+
+/*
+ * check_shared_buffers
+ *		GUC check_hook for shared_buffers
+ *
+ * When reloading the configuration, shared_buffers should not be set to a value
+ * higher than max_shared_buffers fixed at the boot time.
+ */
+bool
+check_shared_buffers(int *newval, void **extra, GucSource source)
+{
+	if (finalMaxNBuffers && *newval > MaxNBuffers)
+	{
+		GUC_check_errdetail("\"shared_buffers\" must be less than \"max_shared_buffers\".");
+		return false;
+	}
+	return true;
+}
+
+/*
+ * show_shared_buffers
+ *		GUC show_hook for shared_buffers
+ *
+ * Shows both current and pending buffer counts with proper unit formatting.
+ */
+const char *
+show_shared_buffers(void)
+{
+	static char buffer[128];
+	int64 current_value, pending_value;
+	const char *current_unit, *pending_unit;
+
+	if (NBuffers == NBuffersPending)
+	{
+		/* No buffer pool resizing pending. */
+		convert_int_from_base_unit(NBuffers, GUC_UNIT_BLOCKS, &current_value, &current_unit);
+		snprintf(buffer, sizeof(buffer), INT64_FORMAT "%s", current_value, current_unit);
+	}
+	else
+	{
+		/*
+		 * New value for NBuffers is loaded but not applied yet, show both
+		 * current and pending.
+		 */
+		convert_int_from_base_unit(NBuffers, GUC_UNIT_BLOCKS, &current_value, &current_unit);
+		convert_int_from_base_unit(NBuffersPending, GUC_UNIT_BLOCKS, &pending_value, &pending_unit);
+		snprintf(buffer, sizeof(buffer), INT64_FORMAT "%s (pending: " INT64_FORMAT "%s)", 
+				 current_value, current_unit, pending_value, pending_unit);
+	}
+	
+	return buffer;
+}
diff --git a/src/backend/storage/buffer/bufmgr.c b/src/backend/storage/buffer/bufmgr.c
index fdcb5556235..14200a38a0f 100644
--- a/src/backend/storage/buffer/bufmgr.c
+++ b/src/backend/storage/buffer/bufmgr.c
@@ -3631,12 +3631,12 @@ static float smoothed_alloc = 0;
 static float smoothed_density = 10.0;
 
 void
-BgBufferSyncReset(int NBuffersOld, int NBuffersNew)
+BgBufferSyncReset(int currentNBuffers, int targetNBuffers)
 {
 	saved_info_valid = false;
 #ifdef BGW_DEBUG
 	elog(DEBUG2, "invalidated background writer status after resizing buffers from %d to %d",
-		 NBuffersOld, NBuffersNew);
+		 currentNBuffers, targetNBuffers);
 #endif
 }
 
@@ -3686,8 +3686,11 @@ BgBufferSync(WritebackContext *wb_context)
 	 * valid. If the buffer pool is being expanded, more buffers will become
 	 * available without even this function writing out any. Hence wait till
 	 * buffer resizing finishes i.e. go into hibernation mode.
+	 * 
+	 * TODO: We may not need this synchronization if background worker itself
+	 * becomes the coordinator.
 	 */
-	if (pg_atomic_read_u32(&ShmemCtrl->NSharedBuffers) != NBuffers)
+	if (!pg_atomic_unlocked_test_flag(&ShmemCtrl->resize_in_progress))
 		return true;
 
 	/*
@@ -3883,7 +3886,7 @@ BgBufferSync(WritebackContext *wb_context)
 	 * finish.
 	 */
 	while (num_to_scan > 0 && reusable_buffers < upcoming_alloc_est &&
-			pg_atomic_read_u32(&ShmemCtrl->NSharedBuffers) == NBuffers)
+			!pg_atomic_unlocked_test_flag(&ShmemCtrl->resize_in_progress))
 	{
 		int			sync_state = SyncOneBuffer(next_to_clean, true,
 											   wb_context);
@@ -4255,7 +4258,23 @@ DebugPrintBufferRefcount(Buffer buffer)
 void
 CheckPointBuffers(int flags)
 {
+	/* Mark that buffer sync is in progress - delay any shared memory resizing. */
+	/*
+	 * TODO: We need to assess whether we should allow checkpoint and buffer
+	 * resizing to run in parallel. When expanding buffers it may be fine to let
+	 * the checkpointer run in RESIZE_MAP_AND_MEM phase but delay phase EXPAND
+	 * phase till the checkpoint finishes, at the same time not allow checkpoint
+	 * to run during expansion phase. When shrinking the buffers, we should
+	 * delay SHRINK phase till checkpoint finishes and not allow to start
+	 * checkpoint till SHRINK phase is done, but allow it to run in
+	 * RESIZE_MAP_AND_MEM phase. This needs careful analysis and testing.
+	 */
+	delay_shmem_resize = true;
+	
 	BufferSync(flags);
+
+	/* Mark that buffer sync is no longer in progress - allow shared memory resizing */
+	delay_shmem_resize = false;
 }
 
 /*
@@ -7504,10 +7523,12 @@ const PgAioHandleCallbacks aio_local_buffer_readv_cb = {
  * of the shrunk buffer pool.
  */
 bool
-EvictExtraBuffers(int newBufSize, int oldBufSize)
+EvictExtraBuffers(int targetNBuffers, int currentNBuffers)
 {
 	bool result = true;
 
+	Assert(targetNBuffers < currentNBuffers);
+
 	/*
 	 * If the buffer being evicated is locked, this function will need to wait.
 	 * This function should not be called from a Postmaster since it can not wait on a lock.
@@ -7515,77 +7536,50 @@ EvictExtraBuffers(int newBufSize, int oldBufSize)
 	Assert(IsUnderPostmaster);
 
 	/*
-	 * Let only one backend perform eviction. We could split the work across all
-	 * the backends but that doesn't seem necessary.
-	 *
-	 * The first backend to acquire ShmemResizeLock, sets its own PID as the
-	 * evictor PID for other backends to know that the eviction is in progress or
-	 * has already been performed. The evictor backend releases the lock when it
-	 * finishes eviction.  While the eviction is in progress, backends other than
-	 * evictor backend won't be able to take the lock. They won't perform
-	 * eviction. A backend may acquire the lock after eviction has completed, but
-	 * it will not perform eviction since the evictor PID is already set. Evictor
-	 * PID is reset only when the buffer resizing finishes. Thus only one backend
-	 * will perform eviction in a given instance of shared buffers resizing.
-	 *
-	 * Any backend which acquires this lock will release it before the eviction
-	 * phase finishes, hence the same lock can be reused for the next phase of
-	 * resizing buffers.
+	 * TODO: Before evicting any buffer, we should check whether any of the
+	 * buffers are pinned. If we find that a buffer is pinned after evicting
+	 * most of them, that will impact performance since all those evicted
+	 * buffers might need to be read again.
 	 */
-	if (LWLockConditionalAcquire(ShmemResizeLock, LW_EXCLUSIVE))
+	for (Buffer buf = targetNBuffers + 1; buf <= currentNBuffers; buf++)
 	{
-		if (ShmemCtrl->evictor_pid == 0)
-		{
-			ShmemCtrl->evictor_pid = MyProcPid;
-
-			/*
-			 * TODO: Before evicting any buffer, we should check whether any of the
-			 * buffers are pinned. If we find that a buffer is pinned after evicting
-			 * most of them, that will impact performance since all those evicted
-			 * buffers might need to be read again.
-			 */
-			for (Buffer buf = newBufSize + 1; buf <= oldBufSize; buf++)
-			{
-				BufferDesc *desc = GetBufferDescriptor(buf - 1);
-				uint32		buf_state;
-				bool		buffer_flushed;
+		BufferDesc *desc = GetBufferDescriptor(buf - 1);
+		uint32		buf_state;
+		bool		buffer_flushed;
 
-				buf_state = pg_atomic_read_u32(&desc->state);
+		buf_state = pg_atomic_read_u32(&desc->state);
 
-				/*
-				 * Nobody is expected to touch the buffers while resizing is
-				 * going one hence unlocked precheck should be safe and saves
-				 * some cycles.
-				 */
-				if (!(buf_state & BM_VALID))
-					continue;
+		/*
+		 * Nobody is expected to touch the buffers while resizing is
+		 * going one hence unlocked precheck should be safe and saves
+		 * some cycles.
+		 */
+		if (!(buf_state & BM_VALID))
+			continue;
 
-				/*
-				 * XXX: Looks like CurrentResourceOwner can be NULL here, find
-				 * another one in that case?
-				 * */
-				if (CurrentResourceOwner)
-					ResourceOwnerEnlarge(CurrentResourceOwner);
+		/*
+		 * XXX: Looks like CurrentResourceOwner can be NULL here, find
+		 * another one in that case?
+		 * */
+		if (CurrentResourceOwner)
+			ResourceOwnerEnlarge(CurrentResourceOwner);
 
-				ReservePrivateRefCountEntry();
+		ReservePrivateRefCountEntry();
 
-				LockBufHdr(desc);
+		LockBufHdr(desc);
 
-				/*
-				 * Now that we have locked buffer descriptor, make sure that the
-				 * buffer without valid data has been skipped above.
-				 */
-				Assert(buf_state & BM_VALID);
+		/*
+		 * Now that we have locked buffer descriptor, make sure that the
+		 * buffer without valid data has been skipped above.
+		 */
+		Assert(buf_state & BM_VALID);
 
-				if (!EvictUnpinnedBufferInternal(desc, &buffer_flushed))
-				{
-					elog(WARNING, "could not remove buffer %u, it is pinned", buf);
-					result = false;
-					break;
-				}
-			}
+		if (!EvictUnpinnedBufferInternal(desc, &buffer_flushed))
+		{
+			elog(WARNING, "could not remove buffer %u, it is pinned", buf);
+			result = false;
+			break;
 		}
-		LWLockRelease(ShmemResizeLock);
 	}
 
 	return result;
diff --git a/src/backend/storage/buffer/freelist.c b/src/backend/storage/buffer/freelist.c
index 55be5eebe0a..c09875934d4 100644
--- a/src/backend/storage/buffer/freelist.c
+++ b/src/backend/storage/buffer/freelist.c
@@ -33,10 +33,16 @@ typedef struct
 	/* Spinlock: protects the values below */
 	slock_t		buffer_strategy_lock;
 
+	/*
+	 * Number of active buffers that can be allocated. During buffer resizing,
+	 * this may be different from NBuffers which tracks the global buffer count.
+	 */
+	pg_atomic_uint32 activeNBuffers;
+
 	/*
 	 * clock-sweep hand: index of next buffer to consider grabbing. Note that
 	 * this isn't a concrete buffer - we only ever increase the value. So, to
-	 * get an actual buffer, it needs to be used modulo NBuffers.
+	 * get an actual buffer, it needs to be used modulo activeNBuffers.
 	 */
 	pg_atomic_uint32 nextVictimBuffer;
 
@@ -101,6 +107,7 @@ static inline uint32
 ClockSweepTick(void)
 {
 	uint32		victim;
+	int			activeBuffers;
 
 	/*
 	 * Atomically move hand ahead one buffer - if there's several processes
@@ -110,12 +117,15 @@ ClockSweepTick(void)
 	victim =
 		pg_atomic_fetch_add_u32(&StrategyControl->nextVictimBuffer, 1);
 
-	if (victim >= NBuffers)
+	/* Read the current active buffer count atomically */
+	activeBuffers = pg_atomic_read_u32(&StrategyControl->activeNBuffers);
+
+	if (victim >= activeBuffers)
 	{
 		uint32		originalVictim = victim;
 
 		/* always wrap what we look up in BufferDescriptors */
-		victim = victim % NBuffers;
+		victim = victim % activeBuffers;
 
 		/*
 		 * If we're the one that just caused a wraparound, force
@@ -143,7 +153,7 @@ ClockSweepTick(void)
 				 */
 				SpinLockAcquire(&StrategyControl->buffer_strategy_lock);
 
-				wrapped = expected % NBuffers;
+				wrapped = expected % activeBuffers;
 
 				success = pg_atomic_compare_exchange_u32(&StrategyControl->nextVictimBuffer,
 														 &expected, wrapped);
@@ -177,6 +187,7 @@ StrategyGetBuffer(BufferAccessStrategy strategy, uint32 *buf_state, bool *from_r
 	BufferDesc *buf;
 	int			bgwprocno;
 	int			trycounter;
+	int		activeNBuffers;
 
 	*from_ring = false;
 
@@ -228,7 +239,9 @@ StrategyGetBuffer(BufferAccessStrategy strategy, uint32 *buf_state, bool *from_r
 	pg_atomic_fetch_add_u32(&StrategyControl->numBufferAllocs, 1);
 
 	/* Use the "clock sweep" algorithm to find a free buffer */
-	trycounter = NBuffers;
+	activeNBuffers = pg_atomic_read_u32(&StrategyControl->activeNBuffers);
+	trycounter = activeNBuffers;
+	
 	for (;;)
 	{
 		uint32		old_buf_state;
@@ -280,7 +293,7 @@ StrategyGetBuffer(BufferAccessStrategy strategy, uint32 *buf_state, bool *from_r
 				if (pg_atomic_compare_exchange_u32(&buf->state, &old_buf_state,
 												   local_buf_state))
 				{
-					trycounter = NBuffers;
+					trycounter = activeNBuffers;
 					break;
 				}
 			}
@@ -323,10 +336,12 @@ StrategySyncStart(uint32 *complete_passes, uint32 *num_buf_alloc)
 {
 	uint32		nextVictimBuffer;
 	int			result;
+	uint32		activeNBuffers;
 
 	SpinLockAcquire(&StrategyControl->buffer_strategy_lock);
 	nextVictimBuffer = pg_atomic_read_u32(&StrategyControl->nextVictimBuffer);
-	result = nextVictimBuffer % NBuffers;
+	activeNBuffers = pg_atomic_read_u32(&StrategyControl->activeNBuffers);
+	result = nextVictimBuffer % activeNBuffers;
 
 	if (complete_passes)
 	{
@@ -336,7 +351,7 @@ StrategySyncStart(uint32 *complete_passes, uint32 *num_buf_alloc)
 		 * Additionally add the number of wraparounds that happened before
 		 * completePasses could be incremented. C.f. ClockSweepTick().
 		 */
-		*complete_passes += nextVictimBuffer / NBuffers;
+		*complete_passes += nextVictimBuffer / activeNBuffers;
 	}
 
 	if (num_buf_alloc)
@@ -391,6 +406,31 @@ StrategyShmemSize(void)
 	return size;
 }
 
+void
+StrategyReset(int activeNBuffers)
+{
+	Assert(StrategyControl);
+
+	SpinLockAcquire(&StrategyControl->buffer_strategy_lock);
+	
+	/* Update the active buffer count for the strategy */
+	pg_atomic_write_u32(&StrategyControl->activeNBuffers, activeNBuffers);
+	
+	/* Reset the clock-sweep pointer to start from beginning */
+	pg_atomic_write_u32(&StrategyControl->nextVictimBuffer, 0);
+
+	/*
+	 * The statistics is viewed in the context of the number of shared buffers.
+	 * Reset it as the size of active number of shared buffers changes.
+	 */
+	StrategyControl->completePasses = 0;
+	pg_atomic_write_u32(&StrategyControl->numBufferAllocs, 0);
+
+	/* TODO: Do we need to seset background writer notifications? */
+	StrategyControl->bgwprocno = -1;
+	SpinLockRelease(&StrategyControl->buffer_strategy_lock);
+}
+
 /*
  * StrategyInitialize -- initialize the buffer cache replacement
  *		strategy.
@@ -416,13 +456,13 @@ StrategyInitialize(bool init)
 	 * directory without rehashing all the entries. Just allocating more entries
 	 * will lead to more contention. Hence we setup the buffer lookup table
 	 * considering the maximum possible size of the buffer pool which is
-	 * MaxAvailableMemory.
+	 * MaxNBuffers.
 	 *
 	 * Additionally BufferAlloc() tries to insert a new entry before deleting the
 	 * old.  In principle this could be happening in each partition concurrently,
 	 * so we need extra NUM_BUFFER_PARTITIONS entries.
 	 */
-	InitBufTable(MaxAvailableMemory + NUM_BUFFER_PARTITIONS);
+	InitBufTable(MaxNBuffers + NUM_BUFFER_PARTITIONS);
 
 	/*
 	 * Get or create the shared strategy control block
@@ -441,6 +481,8 @@ StrategyInitialize(bool init)
 
 		SpinLockInit(&StrategyControl->buffer_strategy_lock);
 
+		/* Initialize the active buffer count */
+		pg_atomic_init_u32(&StrategyControl->activeNBuffers, NBuffersPending);
 		/* Initialize the clock-sweep pointer */
 		pg_atomic_init_u32(&StrategyControl->nextVictimBuffer, 0);
 
@@ -455,62 +497,6 @@ StrategyInitialize(bool init)
 		Assert(!init);
 }
 
-/*
- * StrategyReInitialize -- re-initialize the buffer cache replacement
- *		strategy.
- *
- * To be called when resizing buffer manager and only from the coordinator.
- * TODO: Assess the differences between this function and StrategyInitialize().
- */
-void
-StrategyReInitialize(int FirstBufferIdToInit)
-{
-	bool		found;
-
-	/*
-	 * Resizing memory for buffer pools should not affect the address of
-	 * StrategyControl.
-	 */
-	if (StrategyControl != (BufferStrategyControl *)
-		ShmemInitStructInSegment("Buffer Strategy Status",
-						sizeof(BufferStrategyControl),
-						&found, MAIN_SHMEM_SEGMENT))
-		elog(FATAL, "something went wrong while re-initializing the buffer strategy");
-
-	Assert(found);
-
-	/* TODO: Buffer lookup table adjustment: There are two options:
-	 *
-	 * 1. Resize the buffer lookup table to match the new number of buffers. But
-	 * this requires rehashing all the entries in the buffer lookup table with
-	 * the new table size.
-	 *
-	 * 2. Allocate maximum size of the buffer lookup table at the beginning and
-	 * never resize it. This leaves sparse buffer lookup table which is
-	 * inefficient from both memory and time perspective. According to David
-	 * Rowley, the sparse entries in the buffer look up table cause frequent
-	 * cacheline reload which affect performance. If the impact of that
-	 * inefficiency in a benchmark is significant, we will need to consider first
-	 * option.
-	 */
-	/*
-	 * The clock sweep tick pointer might have got invalidated. Reset it as if
-	 * starting a fresh server.
-	 */
-	pg_atomic_write_u32(&StrategyControl->nextVictimBuffer, 0);
-
-	/*
-	 * The old statistics is viewed in the context of the number of shared
-	 * buffers. It does not make sense now that the number of shared buffers
-	 * itself has changed.
-	 */
-	StrategyControl->completePasses = 0;
-	pg_atomic_init_u32(&StrategyControl->numBufferAllocs, 0);
-
-	/* No pending notification */
-	StrategyControl->bgwprocno = -1;
-}
-
 
 /* ----------------------------------------------------------------
  *				Backend-private buffer ring management
